"use strict";

var _testUtils = require("../../../testUtils");

var _ = require("..");

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _testUtils.testRule)(_2.default, {
  ruleName: _.ruleName,
  config: ["always"],

  accept: [{
    code: ".foo { }"
  }, {
    code: "[ target ] { }"
  }, {
    code: "[  target  ] { }"
  }, {
    code: "[ target=_blank ] { }"
  }, {
    code: "[  target=_blank  ] { }"
  }, {
    code: "[ target='_blank' ] { }"
  }, {
    code: "[ target=\"_blank\" ] { }"
  }, {
    code: "[ title~=flower ] { }"
  }, {
    code: "[ title|=flower ] { }"
  }, {
    code: "[ title^=flower ] { }"
  }, {
    code: "[ title$=flower ] { }"
  }, {
    code: "a[ href*=w3schools ] { }"
  }, {
    code: "img[ alt~=person ][ src*=lorem ] { }"
  }, {
    code: "[ target=_blank ]:hover { }"
  }, {
    code: "[ target=_blank ]::before { }"
  }, {
    code: "option[ data-hidden=true ] { }"
  }, {
    code: "option[ dataHidden ] { }"
  }, {
    code: "@media screen and (max-width: 480px) { img[ align=right ] { } }"
  }, {
    code: "[ target=_blank ] .foo { }"
  }, {
    code: "li[ aria-hidden=false ]:nth-child(1) { }"
  }, {
    code: "li[ aria-hidden=false ]:nth-child( 1) { }"
  }, {
    code: "li[ aria-hidden=false ]:nth-child(1 ) { }"
  }, {
    code: "li[ aria-hidden=false ]:nth-child( 1 ) { }"
  }, {
    code: "ul li[ aria-hidden=false ] + li[ aria-hidden=false ] a { }"
  }, {
    code: "[ target ] { content: \"[\" }"
  }, {
    code: "[ target ] { content: \"]\" }"
  }],

  reject: [{
    code: "[target ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 8
  }, {
    code: "[target  ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[  target] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 9
  }, {
    code: "[target=_blank ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target=_blank] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 15
  }, {
    code: "[target=_blank  ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[  target=_blank] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 16
  }, {
    code: "[target='_blank' ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target='_blank'] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 17
  }, {
    code: "[target=\"_blank\" ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target=\"_blank\"] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 17
  }, {
    code: "a[href*=w3schools ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 3
  }, {
    code: "a[ href*=w3schools] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 18
  }, {
    code: "img[alt~=person ][ src*=lorem ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 5
  }, {
    code: "img[ alt~=person][ src*=lorem ] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 16
  }, {
    code: "img[ alt~=person ][src*=lorem ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 20
  }, {
    code: "img[ alt~=person ][ src*=lorem] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 30
  }, {
    code: "[target=_blank ]:hover { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target=_blank]:hover { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 15
  }, {
    code: "[target=_blank ]::before { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target=_blank]::before { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 15
  }, {
    code: "option[data-hidden=true ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 8
  }, {
    code: "option[ data-hidden=true] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 24
  }, {
    code: "option[dataHidden ] { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 8
  }, {
    code: "option[ dataHidden] { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 18
  }, {
    code: "@media screen and (max-width: 480px) { img[align=right ] { } }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 44
  }, {
    code: "@media screen and (max-width: 480px) { img[ align=right] { } }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 55
  }, {
    code: "[target=_blank ] .foo { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target=_blank] .foo { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 15
  }, {
    code: "li[aria-hidden=false ]:nth-child(1) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 4
  }, {
    code: "li[ aria-hidden=false]:nth-child(1) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 21
  }, {
    code: "li[aria-hidden=false ]:nth-child( 1 ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 4
  }, {
    code: "li[ aria-hidden=false]:nth-child( 1 ) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 21
  }, {
    code: "ul li[aria-hidden=false ] + li[ aria-hidden=false ] a { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 7
  }, {
    code: "ul li[ aria-hidden=false] + li[ aria-hidden=false ] a { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 24
  }, {
    code: "ul li[ aria-hidden=false ] + li[aria-hidden=false ] a { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 33
  }, {
    code: "ul li[ aria-hidden=false ] + li[ aria-hidden=false] a { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 50
  }, {
    code: "[target ] { content: \"[\" }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target] { content: \"[\" }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 8
  }, {
    code: "[target ] { content: \"]\" }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[ target] { content: \"]\" }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 8
  }]
});

(0, _testUtils.testRule)(_2.default, {
  ruleName: _.ruleName,
  config: ["never"],

  accept: [{
    code: ".foo { }"
  }, {
    code: "[target] { }"
  }, {
    code: "[target] { }"
  }, {
    code: "[target=_blank] { }"
  }, {
    code: "[target='_blank'] { }"
  }, {
    code: "[target=\"_blank\"] { }"
  }, {
    code: "[title~=flower] { }"
  }, {
    code: "[title|=flower] { }"
  }, {
    code: "[title^=flower] { }"
  }, {
    code: "[title$=flower] { }"
  }, {
    code: "a[href*=w3schools] { }"
  }, {
    code: "img[alt~=person][src*=lorem] { }"
  }, {
    code: "[target=_blank]:hover { }"
  }, {
    code: "[target=_blank]::before { }"
  }, {
    code: "option[data-hidden=true] { }"
  }, {
    code: "option[dataHidden] { }"
  }, {
    code: "@media screen and (max-width: 480px) { img[align=right] { } }"
  }, {
    code: "[target=_blank] .foo { }"
  }, {
    code: "li[aria-hidden=false]:nth-child(1) { }"
  }, {
    code: "li[aria-hidden=false]:nth-child( 1) { }"
  }, {
    code: "li[aria-hidden=false]:nth-child(1 ) { }"
  }, {
    code: "li[aria-hidden=false]:nth-child( 1 ) { }"
  }, {
    code: "ul li[aria-hidden=false] + li[aria-hidden=false] a { }"
  }, {
    code: "[target] { content: \"[\" }"
  }, {
    code: "[target] { content: \"]\" }"
  }],

  reject: [{
    code: "[ target] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 8
  }, {
    code: "[  target] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target  ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 9
  }, {
    code: "[ target=_blank] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target=_blank ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 15
  }, {
    code: "[  target=_blank] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target=_blank  ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 16
  }, {
    code: "[ target='_blank'] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target='_blank' ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 17
  }, {
    code: "[ target=\"_blank\"] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target=\"_blank\" ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 17
  }, {
    code: "a[ href*=w3schools] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 3
  }, {
    code: "a[href*=w3schools ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 18
  }, {
    code: "img[ alt~=person][src*=lorem] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 5
  }, {
    code: "img[alt~=person ][src*=lorem] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 16
  }, {
    code: "img[alt~=person][ src*=lorem] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 18
  }, {
    code: "img[alt~=person][src*=lorem ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 28
  }, {
    code: "[ target=_blank]:hover { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target=_blank ]:hover { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 15
  }, {
    code: "[ target=_blank]::before { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target=_blank ]::before { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 15
  }, {
    code: "option[ data-hidden=true] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 8
  }, {
    code: "option[data-hidden=true ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 24
  }, {
    code: "option[ dataHidden] { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 8
  }, {
    code: "option[dataHidden ] { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 18
  }, {
    code: "@media screen and (max-width: 480px) { img[ align=right] { } }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 44
  }, {
    code: "@media screen and (max-width: 480px) { img[align=right ] { } }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 55
  }, {
    code: "[ target=_blank] .foo { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target=_blank ] .foo { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 15
  }, {
    code: "li[ aria-hidden=false]:nth-child(1) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 4
  }, {
    code: "li[aria-hidden=false ]:nth-child(1) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 21
  }, {
    code: "li[ aria-hidden=false]:nth-child( 1 ) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 4
  }, {
    code: "li[aria-hidden=false ]:nth-child( 1 ) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 21
  }, {
    code: "ul li[ aria-hidden=false] + li[aria-hidden=false] a { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 7
  }, {
    code: "ul li[aria-hidden=false ] + li[aria-hidden=false] a { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 24
  }, {
    code: "ul li[aria-hidden=false] + li[ aria-hidden=false] a { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 31
  }, {
    code: "ul li[aria-hidden=false] + li[aria-hidden=false ] a { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 48
  }, {
    code: "[ target] { content: \"[\" }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target ] { content: \"[\" }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 8
  }, {
    code: "[ target] { content: \"]\" }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 2
  }, {
    code: "[target ] { content: \"]\" }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 8
  }]
});