"use strict";

var _testUtils = require("../../../testUtils");

var _ = require("..");

var _2 = _interopRequireDefault(_);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

(0, _testUtils.testRule)(_2.default, {
  ruleName: _.ruleName,
  config: ["always"],

  accept: [{
    code: "input:not( [type='submit'] ) { }"
  }, {
    code: "input:not( [type='submit'], [type='text'] ) { }"
  }, {
    code: "input:not(  [type='submit'], [type='text']  ) { }"
  }, {
    code: "p:lang( it ) { }"
  }, {
    code: "section:not( :has( h1, h2 ) ) { }"
  }, {
    code: "input:not( [type='radio'] ):not( [type='checkbox'] ) { }"
  }, {
    code: "a:hover:not( .active ) { }"
  }],

  reject: [{
    code: "input:not([type='submit'] ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 11
  }, {
    code: "input:not( [type='submit']) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 26
  }, {
    code: "input:not([type='submit'], [type='text'] ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 11
  }, {
    code: "input:not( [type='submit'], [type='text']) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 41
  }, {
    code: "input:not(  [type='submit']) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 27
  }, {
    code: "section:not(:has( h1, h2 ) ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 13
  }, {
    code: "section:not( :has( h1, h2 )) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 27
  }, {
    code: "section:not( :has(h1, h2 ) ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 19
  }, {
    code: "section:not( :has( h1, h2) ) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 25
  }, {
    code: "input:not([type='radio'] ):not( [type='checkbox'] ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 11
  }, {
    code: "input:not( [type='radio']):not( [type='checkbox'] ) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 25
  }, {
    code: "input:not( [type='radio'] ):not([type='checkbox'] ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 33
  }, {
    code: "input:not( [type='radio'] ):not( [type='checkbox']) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 50
  }, {
    code: "a:hover:not(.active ) { }",
    message: _.messages.expectedOpening,
    line: 1,
    column: 13
  }, {
    code: "a:hover:not( .active) { }",
    message: _.messages.expectedClosing,
    line: 1,
    column: 20
  }]
});

(0, _testUtils.testRule)(_2.default, {
  ruleName: _.ruleName,
  config: ["never"],

  accept: [{
    code: "input:not([type='submit']) { }"
  }, {
    code: "input:not([type='submit'], [type='text']) { }"
  }, {
    code: "input:not([type='submit'], [type='text']) { }"
  }, {
    code: "p:lang(it) { }"
  }, {
    code: "section:not(:has(h1, h2)) { }"
  }, {
    code: "input:not([type='radio']):not([type='checkbox']) { }"
  }, {
    code: "a:hover:not(.active) { }"
  }],

  reject: [{
    code: "input:not([type='submit'] ) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 26
  }, {
    code: "input:not( [type='submit']) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 11
  }, {
    code: "input:not([type='submit'], [type='text'] ) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 41
  }, {
    code: "input:not( [type='submit'], [type='text']) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 11
  }, {
    code: "input:not(  [type='submit']) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 11
  }, {
    code: "section:not( :has(h1, h2)) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 13
  }, {
    code: "section:not(:has( h1, h2)) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 18
  }, {
    code: "section:not(:has(h1, h2) ) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 25
  }, {
    code: "section:not(:has(h1, h2 )) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 24
  }, {
    code: "input:not( [type='radio']):not([type='checkbox']) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 11
  }, {
    code: "input:not([type='radio'] ):not([type='checkbox']) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 25
  }, {
    code: "input:not([type='radio']):not( [type='checkbox']) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 31
  }, {
    code: "input:not([type='radio']):not([type='checkbox'] ) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 48
  }, {
    code: "a:hover:not( .active) { }",
    message: _.messages.rejectedOpening,
    line: 1,
    column: 13
  }, {
    code: "a:hover:not(.active ) { }",
    message: _.messages.rejectedClosing,
    line: 1,
    column: 20
  }]
});